const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

customer_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"residential",


"commercial"

        ],

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

billing_address: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.customers.hasMany(db.properties, {
      as: 'properties_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.jobs, {
      as: 'jobs_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });








    db.customers.hasMany(db.invoices, {
      as: 'invoices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.payments, {
      as: 'payments_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.estimates, {
      as: 'estimates_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.recurring_schedules, {
      as: 'recurring_schedules_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });







//end loop



    db.customers.belongsTo(db.workspaces, {
      as: 'workspace',
      foreignKey: {
        name: 'workspaceId',
      },
      constraints: false,
    });

    db.customers.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


